/*
 * JBoss, Home of Professional Open Source
 * Copyright 2006, JBoss Inc., and others contributors as indicated 
 * by the @authors tag. All rights reserved. 
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors. 
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 * 
 * (C) 2005-2006,
 * @author JBoss Inc.
 */
package org.jboss.soa.esb.samples.quickstart.juddiperf;

import java.util.List;

import org.jboss.soa.esb.listeners.config.ServicePublisher;
import org.jboss.soa.esb.actions.AbstractActionLifecycle;
import org.jboss.soa.esb.helpers.ConfigTree;
import org.jboss.soa.esb.message.Message;

import org.jboss.soa.esb.services.registry.RegistryFactory;
import org.jboss.soa.esb.services.registry.Registry;
import org.jboss.soa.esb.services.registry.RegistryException;
import org.jboss.soa.esb.Service;
import org.jboss.soa.esb.addressing.EPR;

public class MyJMSListenerAction extends AbstractActionLifecycle
{
    
  protected ConfigTree	_config;
	  
  public MyJMSListenerAction(ConfigTree config) { _config = config; } 

  public void getEPRLists(int count, String category, String name) 
	throws Exception {
	Registry registry = RegistryFactory.getRegistry();
	long start = System.currentTimeMillis();
	for (int i = 0; i < count; i++) {
	List eprs = (List) registry.findEPRs(category, name);
	}
	long end = System.currentTimeMillis();

	System.out.println("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&");
	System.out.println("Fetched " + count + " EPR lists in " + (end-start)
		+ " ms for category " + category + " name " + name);
        System.out.println("&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&");
  }
  
  public Message displayMessage(Message message) throws Exception{
	Registry registry = RegistryFactory.getRegistry();
	long start, end;
	List<Service>services = ServicePublisher.getServices();

	for (Service service : services) {
       		String category = service.getCategory();
        	String name = service.getName();
	
		getEPRLists(1, category, name);
		getEPRLists(10, category, name);
		getEPRLists(100, category, name);
		getEPRLists(1000, category, name);	
	}	
	return message; 
  }
    
	
}
