package org.jboss.soa.esb.samples.quickstart.juddiperf.test;

import org.apache.juddi.uuidgen.UUIDGen;
import org.apache.juddi.uuidgen.UUIDGenFactory;
import java.util.Properties;

import java.sql.*;

public class CreateEPR {
    Connection conn;
    String insertQuery = "insert into BINDING_TEMPLATE "
		+ "(SERVICE_KEY, BINDING_KEY, ACCESS_POINT_TYPE, "
		+ "ACCESS_POINT_URL) VALUES (?,?,?,?)";    
   
    public CreateEPR() {
	try {
   	Class.forName("com.mysql.jdbc.Driver").newInstance();
	conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/test",
		"root", "");
	} catch (Exception e) {
		e.printStackTrace();
	}	 
    }
	
    public void close() {
	try {
    	conn.close();
	} catch (Exception e) {
	e.printStackTrace();
	}
    }

    public void insertEPRS(String numEPRString) {
   	int numepr = Integer.parseInt(numEPRString);
	UUIDGen uuidgen = UUIDGenFactory.getUUIDGen();
	try { 
		PreparedStatement ps = conn.prepareStatement(insertQuery);
		Statement s = conn.createStatement();
		s.executeQuery("select distinct SERVICE_KEY, "
			+ "ACCESS_POINT_TYPE, ACCESS_POINT_URL "
			+ "from BINDING_TEMPLATE");
		ResultSet rs = s.getResultSet();
		while (rs.next()) {
			String serviceKey = rs.getString("SERVICE_KEY");
			String accessType = rs.getString("ACCESS_POINT_TYPE");
			String accessURL = rs.getString("ACCESS_POINT_URL");
			for (int i = 0; i < numepr; i++) {	
				int st = 1;
				ps.setString(st++,serviceKey);
				String uuid = uuidgen.uuidgen();
				ps.setString(st++,uuid);
				ps.setString(st++,accessType);
				ps.setString(st++,accessURL);
				ps.executeUpdate();
			}
		}
		s.close();
		ps.close();
	} catch (Exception e) {
		e.printStackTrace();	
	} 
    }
 
    public static void main(String args[]) throws Exception
    {        	    	
    	CreateEPR cepr = new CreateEPR();
    	cepr.insertEPRS(args[0]); 
    	cepr.close();
    }
    
}
